## 8.049.02
#https://github.com/mtorromeo/r8168/archive/8.051.02.tar.gz
# patch for kernel-5.4.1
#https://github.com/rockyprabowo/r8168

%global		module r8168
 
Name:		dkms-%{module}
Version:	8.051.02
Release:	%mkrel 1
License:	GPLv2
Group:		System/Kernel and hardware
URL:		https://www.realtek.com/en/
Summary:	dkms package for %{module} driver
Source0:	%{module}-%{version}.tar.xz

#Source1:	linux-40.patch
#Source2:	linux-47.patch
#Source3:	linux-48.patch
# from aur
#Source4:	linux-4.11.patch
## from me
#Source5:	linux-4.12.patch
#Source6:	linux-4.13.patch
#Source7:	linux-4.15.patch
#Source8:	linux-4.16.patch
#Source9:	linux-4.17.patch
#Source10:	linux-4.18.patch
# on kernel-5.4.1 no #include <linux/pci-aspm.h> foundable
Source11:	r8168-kernel-5.4.1.patch
Source12:	r8168-kernel-5.6.3.patch

# just on kernel-5.18.2 up to 5.19.rc1
Patch0:	r8168-kernel-5.17.patch
# ready in 8.051.02 #Patch1:	r8168-kernel-5.18.2.patch 	
# ready in 8.051.02 #Patch2:	r8168-kernel-5.18.2-2th.patch
# ready in 8.051.02 #Patch3: r8168-kernel-5.18.patch
Patch1:	r8168-kernel-6.1.patch

Patch3:	r8168-8.051.02-Makefile.patch



BuildRoot:	%defaultbuildroot

Requires(post,preun): dkms
Requires: 	kernel
Requires:   gcc >= 9.2.0
Obsoletes:	%{module} <= %{version}-%{release}


%description
for finetune read on README in /usr/share/doc...

This package provides the r8168 kernel module(s) for Realtek RTL8168/RTL8111,
RTL8168B/RTL8111B, RTL8168C/RTL8111C, RTL8168D/RTL8111D, RTL8168E/RTL8111E and RTL8168F/RTL8111F
Gigabit Ethernet NICs built for the Linux kernel using the x86_64 family of processors.

RTL8111B/RTL8168B/RTL8111/RTL8168
RTL8111C/RTL8111CP/RTL8111D(L)
RTL8168C/RTL8111DP/RTL8111E
RTL8168E/RTL8111F/RTL8411
RTL8111G/RTL8111GUS/RTL8411B(N)
RTL8118AS

%prep
%setup -qn %{module}-%{version}
find -type f -exec chmod 0644 {} \;

%apply_patches

%install
%__rm -rf %{buildroot}
%__mkdir -p %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}

%__cp -a ./src/* %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}

cat <<EOF > %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{module}"
PACKAGE_VERSION="%{version}-%{release}"
BUILT_MODULE_NAME[0]="%{module}"
BUILT_MODULE_LOCATION[0]="./"
DEST_MODULE_LOCATION[0]="/kernel/3rdparty/R8168"
MAKE[0]="export IGNORE_CC_MISMATCH=1; 'make' clean KSRC=\${kernel_source_dir} EXTRA_CFLAGS=' -DCONFIG_R8168_NAPI=y -DCONFIG_R8168_VLAN=y -DCONFIG_ASPM=y -DENABLE_S5WOL=y -DENABLE_EEE=y ' SKIP_STACK_VALIDATION=1 modules"
AUTOINSTALL="yes"
CLEAN="make clean"
EOF

# add r8168.conf in /etc/modprobe.d
mkdir -p %{buildroot}/etc/modprobe.d
cat <<EOF > %{buildroot}/etc/modprobe.d/r8168.conf
blacklist r8169
EOF


%post -n dkms-%{module}
/sbin/rmmod r8168 > /dev/null 2>&1
## also clean olders in /extra... there was only modules, not a directory
find ./lib/modules/** -type f -name "r8168*.xz" -exec rm {} \; >/dev/null 2>&1
/usr/sbin/dkms --rpm_safe_upgrade add -m %{module} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade build -m %{module} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade install -m %{module} -v %{version}-%{release} || :

if [ "$1" = 1 ]; then
/sbin/rmmod r8169 > /dev/null 2>&1
/sbin/modprobe r8168 > /dev/null 2>&1
sed -i '/r8169/ d' /etc/modprobe.preload 2>&1
/sbin/service network reload > /dev/null 2>&1
echo "Reloading network configuration ... "
echo "blacklist r8169" >> /etc/modprobe.d/blacklist 2>&1
echo "r8168" >> /etc/modprobe.preload 2>&1
echo -e \
'\n> The module r8168 conflicts with r8169. Module r8169 has just been blacklisted by adding it to
> /etc/modprobe.d/blacklist file. Module r8168 will be loaded automatically at boot time from next boot.
> Deinstallation of dkms-r8168 package will revert changes to a previous state.\n'
fi

%preun -n dkms-%{module}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{module} -v %{version}-%{release} --all || :

if [ "$1" = 0 ]; then
/sbin/rmmod r8168 > /dev/null 2>&1
/sbin/modprobe r8169 > /dev/null 2>&1
/sbin/service network reload > /dev/null 2>&1
echo "Reloading network configuration ... "
sed -i '/r8169/ d' /etc/modprobe.d/blacklist 2>&1
sed -i '/r8168/ d' /etc/modprobe.preload 2>&1
fi
## remove module-destdir just if it empty after dkms remove,(user's only deinstall after testing)... ##
## so prevent we not have empty folders in kernel-tree for next mklivecd ##
if [ ! -f /lib/modules/*/kernel/3rdparty/realtek/* ]; then
rm -r /lib/modules/*/kernel/3rdparty/realtek >/dev/null 2>&1
fi
## also clean olders in /extra... there was only modules, not a directory
find ./lib/modules/** -type f -name "r8168*.xz" -exec rm {} \; >/dev/null 2>&1

%clean
%__rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc README
%{_usrsrc}/%{module}-%{version}-%{release}
/etc/modprobe.d/r8168.conf

%changelog
* Tue Dec 27 2022 onkelho <oh.quait at gmail.com> - 8.051.02-1pclos2022
- new version released
- add patch bulding for k-6.1...
- drop 5.18er patches, now on source-new-version

* Sun Jul 17 2022 onkelho <oh.quait at gmail.com> - 8.050.03-1pclos2022
- new version

* Thu Jun 16 2022 onkelho <oh.quait at gmail.com> - 8.050.02-6pclos2022
- rebuild
- add patch3 r8168-kernel-5.18 from aur
- drop patch2 r8168-kernel-5.18.2-2th

* Sat Jun 11 2022 onkelho <oh.quait at gmail.com> - 8.050.02-5pclos2022
- rebuild - drop patch100

* Sat Jun 11 2022 onkelho <oh.quait at gmail.com> - 8.050.02-4pclos2022
- rebuild

* Fri Jun 10 2022 onkelho <oh.quait at gmail.com> - 8.050.02-3pclos2022
- rebuild
- - fix patch2 end's up of middle of line

* Wed Jun 08 2022 onkelho <oh.quait at gmail.com> - 8.050.02-2pclos2022
- rebuild

* Sat May 28 2022 onkelho <oh.quait at gmail.com> - 8.050.02-1pclos2022
- update new version released  

* Wed May 11 2022 onkelho <oh.quait at gmail.com> - 8.050.00-1pclos2022
- new version release

* Mon Jan 31 2022 onkelho <oh.quait at gmail.com> - 8.049.02-2pclos2022
- rebuid
- ?SYS?K?SRC=\${kernel_source_dir},  := -> ?= in MAKE

* Mon Jan 31 2022 onkelho <oh.quait at gmail.com> - 8.049.02-1pclos2022
- updates kerv-5.17
- add export IGNORE_CC_MISMATCH=1;
